# Generated by Django 4.1.9 on 2023-06-12 09:25

import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import hitcount.models
import modelcluster.contrib.taggit
import modelcluster.fields
import waggylabs.blocks.icon
import waggylabs.blocks.label
import waggylabs.blocks.markdown
import waggylabs.blocks.table
import waggylabs.fields.markdown
import wagtail.blocks
import wagtail.contrib.routable_page.models
import wagtail.documents.blocks
import wagtail.embeds.blocks
import wagtail.fields
import wagtail.images.blocks
import wagtailmetadata.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('taggit', '0005_auto_20220424_2025'),
        ('wagtailimages', '0025_alter_image_file_alter_rendition_file'),
        ('wagtailcore', '0083_workflowcontenttype'),
    ]

    operations = [
        migrations.CreateModel(
            name='BasePage',
            fields=[
                ('page_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='wagtailcore.page')),
                ('title_style', models.CharField(blank=True, choices=[('', 'Page title style'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6')], default='', max_length=10, verbose_name='Page title style')),
                ('created_at', models.DateTimeField(auto_now_add=True)),
                ('embed_caption_label', models.CharField(blank=True, help_text='For example, Embed. The label will be used to create embed labels before caption. Leave empty for no label.', max_length=50, verbose_name='Label for embeds')),
                ('equation_caption_label', models.CharField(blank=True, help_text='For example, Eqn. The label will be used to create equatoion labels before caption. Note, that equation labels are displayed only in preview dialogs. Leave empty for no label.', max_length=50, verbose_name='Label for equations')),
                ('figure_caption_label', models.CharField(blank=True, help_text='For example, Figure. The label will be used to create figure labels before caption. Leave empty for no label.', max_length=50, verbose_name='Label for figures')),
                ('listing_caption_label', models.CharField(blank=True, help_text='For example, Listing. The label will be used to create listing labels before caption. Leave empty for no label.', max_length=50, verbose_name='Label for listings')),
                ('table_caption_label', models.CharField(blank=True, help_text='For example, Table. The label will be used to create table labels before caption. Leave empty for no label.', max_length=50, verbose_name='Label for tables')),
                ('show_sidebar', models.BooleanField(blank=True, default=False, help_text='Controls the display of sidebar.', verbose_name='Show sidebar')),
                ('sidebar', wagtail.fields.StreamField([('sidebar', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Fixed'), ('sticky-top', 'Sticky')], label='Style of the sidebar', required=False)), ('items', wagtail.blocks.StreamBlock([('text', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Text', required=True))])), ('citations', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False))]))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('page_info', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('show_user', wagtail.blocks.BooleanBlock(label='Show the name of the page creator', required=False)), ('user_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator name is displayed.', label='Header of the page creator row', required=False)), ('show_avatar', wagtail.blocks.BooleanBlock(label='Show avatar', required=False)), ('avatar_location', wagtail.blocks.ChoiceBlock(choices=[('start', 'Before username'), ('end', 'After username')], label='Avatar location', required=False)), ('show_email', wagtail.blocks.BooleanBlock(label='Show the email of page creator', required=False)), ('email_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator email is displayed.', label='Header of the page creator email row', required=False)), ('show_first_published_at', wagtail.blocks.BooleanBlock(label='Date of page publication', required=False)), ('first_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page publciation date is displayed.', label='Header of the page publication date', required=False)), ('show_last_published_at', wagtail.blocks.BooleanBlock(label='Date of last page update', required=False)), ('last_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the last page update is displayed.', label='Header of last page update', required=False)), ('datetime_style', wagtail.blocks.ChoiceBlock(choices=[('date', 'Only date'), ('datetime', 'Date and time'), ('timesince', 'Time since')], label='Date style')), ('time_format', wagtail.blocks.ChoiceBlock(choices=[('G:i', '24-hour format'), ('g:i A', '12-hour format')], label='Time format')), ('timesince_text', wagtail.blocks.CharBlock(label='Time since text, e.g. ago', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('row_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row header style', required=False)), ('row_data_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row style', required=False))]))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_series', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('current_post_style', wagtail.blocks.ChoiceBlock(choices=[('active', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Current post style'))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('tabs', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('tabs_style', wagtail.blocks.ChoiceBlock(choices=[('nav nav-tabs', 'Tabs'), ('nav nav-pills', 'Pills'), ('nav nav-pills nav-fill', 'Wide pills')], label='Tabs style', required=False)), ('buttons_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tab buttons style', required=False)), ('tabs_font_size', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Tabs font size', required=False)), ('tabs_orientation', wagtail.blocks.ChoiceBlock(choices=[('', 'Horizontal'), ('flex-column', 'Vertical')], label='Tabs orientation', required=False)), ('tabs_justify', wagtail.blocks.ChoiceBlock(choices=[('justify-content-start', 'Align left'), ('justify-content-center', 'Align center'), ('justify-content-end', 'Align right')], label='Tabs horizontal alignment')), ('items', wagtail.blocks.StreamBlock([('text', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Text', required=True))])), ('citations', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False))]))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('page_info', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('show_user', wagtail.blocks.BooleanBlock(label='Show the name of the page creator', required=False)), ('user_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator name is displayed.', label='Header of the page creator row', required=False)), ('show_avatar', wagtail.blocks.BooleanBlock(label='Show avatar', required=False)), ('avatar_location', wagtail.blocks.ChoiceBlock(choices=[('start', 'Before username'), ('end', 'After username')], label='Avatar location', required=False)), ('show_email', wagtail.blocks.BooleanBlock(label='Show the email of page creator', required=False)), ('email_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator email is displayed.', label='Header of the page creator email row', required=False)), ('show_first_published_at', wagtail.blocks.BooleanBlock(label='Date of page publication', required=False)), ('first_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page publciation date is displayed.', label='Header of the page publication date', required=False)), ('show_last_published_at', wagtail.blocks.BooleanBlock(label='Date of last page update', required=False)), ('last_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the last page update is displayed.', label='Header of last page update', required=False)), ('datetime_style', wagtail.blocks.ChoiceBlock(choices=[('date', 'Only date'), ('datetime', 'Date and time'), ('timesince', 'Time since')], label='Date style')), ('time_format', wagtail.blocks.ChoiceBlock(choices=[('G:i', '24-hour format'), ('g:i A', '12-hour format')], label='Time format')), ('timesince_text', wagtail.blocks.CharBlock(label='Time since text, e.g. ago', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('row_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row header style', required=False)), ('row_data_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row style', required=False))]))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_series', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('current_post_style', wagtail.blocks.ChoiceBlock(choices=[('active', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Current post style'))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('toc', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False))]))])), ('visuals', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('preview_buttons_text', wagtail.blocks.CharBlock(label='Preview buttons text', required=False)), ('preview_buttons_icon', waggylabs.blocks.icon.IconBlock(label='Preview buttons icon', required=False)), ('preview_buttons_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Preview buttons icon location', required=False)), ('preview_buttons_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Preview buttons style', required=False)), ('include_embeds', wagtail.blocks.BooleanBlock(label='Include embeds', required=False)), ('include_equations', wagtail.blocks.BooleanBlock(label='Include equations', required=False)), ('include_figures', wagtail.blocks.BooleanBlock(label='Include figures', required=False)), ('include_listings', wagtail.blocks.BooleanBlock(label='Include listings', required=False)), ('include_tables', wagtail.blocks.BooleanBlock(label='Include tables', required=False))]))]))]))]))])), ('toc', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False))]))])), ('visuals', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('preview_buttons_text', wagtail.blocks.CharBlock(label='Preview buttons text', required=False)), ('preview_buttons_icon', waggylabs.blocks.icon.IconBlock(label='Preview buttons icon', required=False)), ('preview_buttons_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Preview buttons icon location', required=False)), ('preview_buttons_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Preview buttons style', required=False)), ('include_embeds', wagtail.blocks.BooleanBlock(label='Include embeds', required=False)), ('include_equations', wagtail.blocks.BooleanBlock(label='Include equations', required=False)), ('include_figures', wagtail.blocks.BooleanBlock(label='Include figures', required=False)), ('include_listings', wagtail.blocks.BooleanBlock(label='Include listings', required=False)), ('include_tables', wagtail.blocks.BooleanBlock(label='Include tables', required=False))]))]))]))]))], blank=True, use_json_field=True)),
                ('search_image', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='wagtailimages.image', verbose_name='Search image')),
            ],
            options={
                'abstract': False,
            },
            bases=(wagtailmetadata.models.WagtailImageMetadataMixin, 'wagtailcore.page', models.Model, hitcount.models.HitCountMixin),
        ),
        migrations.CreateModel(
            name='PostCategory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', waggylabs.fields.markdown.MarkdownField()),
                ('slug', models.SlugField(max_length=255, unique=True)),
                ('created_at', models.DateTimeField(auto_now_add=True)),
            ],
            options={
                'verbose_name': 'Category',
                'verbose_name_plural': 'Categories',
            },
        ),
        migrations.CreateModel(
            name='TagProxy',
            fields=[
            ],
            options={
                'verbose_name': 'Tag',
                'verbose_name_plural': 'Tags',
                'proxy': True,
                'indexes': [],
                'constraints': [],
            },
            bases=('taggit.tag',),
        ),
        migrations.CreateModel(
            name='PostListPage',
            fields=[
                ('basepage_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='waggylabs.basepage')),
                ('repeat_in_subnav', models.BooleanField(default=False, help_text="If checked, a link to this page will be repeated alongside it's direct children when displaying a sub-navigation for this page.", verbose_name='repeat in sub-navigation')),
                ('repeated_item_text', models.CharField(blank=True, help_text="e.g. 'Section home' or 'Overview'. If left blank, the page title will be used.", max_length=255, verbose_name='repeated item link text')),
                ('body', wagtail.fields.StreamField([('accordion', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('collapsible', 'Items collapse'), ('stays_open', 'Items stay open')], help_text='Collapse items when new items opens or keep them open', label='Item collapse style')), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('heading', wagtail.blocks.CharBlock(form_classname='full subtitle', label='Item heading', required=True)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('is_open', wagtail.blocks.BooleanBlock(label='Item is displayed expanded', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], required=False))])))])), ('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('card_grid', wagtail.blocks.StructBlock([('height_style', wagtail.blocks.ChoiceBlock(choices=[('h-100', 'Equal height'), ('', 'Height wraps to content')], label='Card height style', required=False)), ('grouping_style', wagtail.blocks.ChoiceBlock(choices=[('separate', 'Separate'), ('grouped', 'Grouped')], label='Card grouping style', required=False)), ('orientation_style', wagtail.blocks.ChoiceBlock(choices=[('vertical', 'Vertical'), ('horizontal', 'Horizontal')], label='Card orientation', required=False)), ('columns', wagtail.blocks.ChoiceBlock(choices=[(1, '1 column'), (2, '2 columns'), (3, '3 columns')], label='Number of columns', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Image', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('title', wagtail.blocks.CharBlock(label='Card title', required=True)), ('subtitle', wagtail.blocks.CharBlock(label='Card subtitle', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, required=False)), ('links', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('email', wagtail.blocks.StructBlock([('email', wagtail.blocks.EmailBlock(label='Email address', required=True)), ('text', wagtail.blocks.CharBlock(label='Text instead of email', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Email icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Email icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Email style', required=False))])), ('info_text', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Phone, address, etc.', required=True)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Style', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Icon location', required=False))]))], required=False))])))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('collapse', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the button', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False)), ('button_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], requred=True))])), ('columns', wagtail.blocks.StructBlock([('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('vertical_align', wagtail.blocks.ChoiceBlock(choices=[('align-self-start', 'Top'), ('align-self-center', 'Center'), ('align-self-end', 'Bottom')], label='Column content vertical alignment')), ('body', wagtail.blocks.StreamBlock([('accordion', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('collapsible', 'Items collapse'), ('stays_open', 'Items stay open')], help_text='Collapse items when new items opens or keep them open', label='Item collapse style')), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('heading', wagtail.blocks.CharBlock(form_classname='full subtitle', label='Item heading', required=True)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('is_open', wagtail.blocks.BooleanBlock(label='Item is displayed expanded', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], required=False))])))])), ('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('collapse', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the button', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False)), ('button_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], requred=True))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(help_text=''))], required=False))]), max_num=3, min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('cut', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the cut button', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('page_info', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('show_user', wagtail.blocks.BooleanBlock(label='Show the name of the page creator', required=False)), ('user_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator name is displayed.', label='Header of the page creator row', required=False)), ('show_avatar', wagtail.blocks.BooleanBlock(label='Show avatar', required=False)), ('avatar_location', wagtail.blocks.ChoiceBlock(choices=[('start', 'Before username'), ('end', 'After username')], label='Avatar location', required=False)), ('show_email', wagtail.blocks.BooleanBlock(label='Show the email of page creator', required=False)), ('email_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator email is displayed.', label='Header of the page creator email row', required=False)), ('show_first_published_at', wagtail.blocks.BooleanBlock(label='Date of page publication', required=False)), ('first_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page publciation date is displayed.', label='Header of the page publication date', required=False)), ('show_last_published_at', wagtail.blocks.BooleanBlock(label='Date of last page update', required=False)), ('last_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the last page update is displayed.', label='Header of last page update', required=False)), ('datetime_style', wagtail.blocks.ChoiceBlock(choices=[('date', 'Only date'), ('datetime', 'Date and time'), ('timesince', 'Time since')], label='Date style')), ('time_format', wagtail.blocks.ChoiceBlock(choices=[('G:i', '24-hour format'), ('g:i A', '12-hour format')], label='Time format')), ('timesince_text', wagtail.blocks.CharBlock(label='Time since text, e.g. ago', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('row_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row header style', required=False)), ('row_data_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row style', required=False))]))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock()), ('post_list', wagtail.blocks.StructBlock([('show_pinned_posts', wagtail.blocks.BooleanBlock(label='Show pinned posts', required=False)), ('pinned_posts_header', wagtail.blocks.CharBlock(label='Pinned posts header', required=False)), ('pinned_posts_icon', waggylabs.blocks.icon.IconBlock(label='Pinned posts icon', required=False)), ('pinned_posts_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Pinned posts icon location', required=False)), ('pinned_posts_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Pinned posts header style', required=False)), ('posts_header', wagtail.blocks.CharBlock(label='Post list header', required=False)), ('posts_icon', waggylabs.blocks.icon.IconBlock(label='Post list icon', required=False)), ('posts_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Post list icon location', required=False)), ('posts_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Post list header style', required=False)), ('first_page_text', wagtail.blocks.CharBlock(label='First page button text', required=False)), ('first_page_icon', waggylabs.blocks.icon.IconBlock(label='First page button icon', required=False)), ('previous_page_text', wagtail.blocks.CharBlock(label='Previous page button text', required=False)), ('previous_page_icon', waggylabs.blocks.icon.IconBlock(label='Previous page button icon', required=False)), ('next_page_text', wagtail.blocks.CharBlock(label='Next page button text', required=False)), ('next_page_icon', waggylabs.blocks.icon.IconBlock(label='Next page button icon', required=False)), ('last_page_text', wagtail.blocks.CharBlock(label='Last page button text', required=False)), ('last_page_icon', waggylabs.blocks.icon.IconBlock(label='Last page button icon', required=False)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Post style in the list', required=False)), ('post_title_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Post title style', required=False)), ('page_alignment', wagtail.blocks.ChoiceBlock(choices=[('justify-content-start', 'Left'), ('justify-content-center', 'Center'), ('justify-content-end', 'Right')], label='Paginator alignment')), ('page_size', wagtail.blocks.ChoiceBlock(choices=[('', 'Normal'), ('pagination-sm', 'Small'), ('pagination-lg', 'Large')], label='Paginator text size', required=False)), ('posts_per_page', wagtail.blocks.IntegerBlock(label='Posts per page', min_value=1, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending')], label='Categories ordering')), ('show_scrollspy', wagtail.blocks.BooleanBlock(label='Highlight post categories and tags when corresponding sidebar blocks are present', required=False)), ('show_username', wagtail.blocks.BooleanBlock(label='Show username', required=False)), ('show_avatar', wagtail.blocks.BooleanBlock(label='Show avatar', required=False)), ('show_first_published_at', wagtail.blocks.BooleanBlock(label='Date of page publication', required=False)), ('datetime_style', wagtail.blocks.ChoiceBlock(choices=[('date', 'Only date'), ('datetime', 'Date and time'), ('timesince', 'Time since')], label='Date style')), ('show_time', wagtail.blocks.BooleanBlock(label='Show time in the date fields', required=False)), ('time_format', wagtail.blocks.ChoiceBlock(choices=[('G:i', '24-hour format'), ('g:i A', '12-hour format')], label='Time format')), ('timesince_text', wagtail.blocks.CharBlock(label='Time since text, e.g. ago', required=False))]))], blank=True, use_json_field=True)),
            ],
            options={
                'abstract': False,
            },
            bases=(wagtail.contrib.routable_page.models.RoutablePageMixin, 'waggylabs.basepage', models.Model),
        ),
        migrations.CreateModel(
            name='PostPage',
            fields=[
                ('basepage_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='waggylabs.basepage')),
                ('body', wagtail.fields.StreamField([('accordion', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('collapsible', 'Items collapse'), ('stays_open', 'Items stay open')], help_text='Collapse items when new items opens or keep them open', label='Item collapse style')), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('heading', wagtail.blocks.CharBlock(form_classname='full subtitle', label='Item heading', required=True)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('is_open', wagtail.blocks.BooleanBlock(label='Item is displayed expanded', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], required=False))])))])), ('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('card_grid', wagtail.blocks.StructBlock([('height_style', wagtail.blocks.ChoiceBlock(choices=[('h-100', 'Equal height'), ('', 'Height wraps to content')], label='Card height style', required=False)), ('grouping_style', wagtail.blocks.ChoiceBlock(choices=[('separate', 'Separate'), ('grouped', 'Grouped')], label='Card grouping style', required=False)), ('orientation_style', wagtail.blocks.ChoiceBlock(choices=[('vertical', 'Vertical'), ('horizontal', 'Horizontal')], label='Card orientation', required=False)), ('columns', wagtail.blocks.ChoiceBlock(choices=[(1, '1 column'), (2, '2 columns'), (3, '3 columns')], label='Number of columns', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Image', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('title', wagtail.blocks.CharBlock(label='Card title', required=True)), ('subtitle', wagtail.blocks.CharBlock(label='Card subtitle', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, required=False)), ('links', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('email', wagtail.blocks.StructBlock([('email', wagtail.blocks.EmailBlock(label='Email address', required=True)), ('text', wagtail.blocks.CharBlock(label='Text instead of email', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Email icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Email icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Email style', required=False))])), ('info_text', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Phone, address, etc.', required=True)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Style', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Icon location', required=False))]))], required=False))])))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('collapse', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the button', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False)), ('button_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], requred=True))])), ('columns', wagtail.blocks.StructBlock([('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('vertical_align', wagtail.blocks.ChoiceBlock(choices=[('align-self-start', 'Top'), ('align-self-center', 'Center'), ('align-self-end', 'Bottom')], label='Column content vertical alignment')), ('body', wagtail.blocks.StreamBlock([('accordion', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('collapsible', 'Items collapse'), ('stays_open', 'Items stay open')], help_text='Collapse items when new items opens or keep them open', label='Item collapse style')), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('heading', wagtail.blocks.CharBlock(form_classname='full subtitle', label='Item heading', required=True)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('is_open', wagtail.blocks.BooleanBlock(label='Item is displayed expanded', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], required=False))])))])), ('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('collapse', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the button', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False)), ('button_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], requred=True))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(help_text=''))], required=False))]), max_num=3, min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('cut', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the cut button', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('page_info', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('show_user', wagtail.blocks.BooleanBlock(label='Show the name of the page creator', required=False)), ('user_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator name is displayed.', label='Header of the page creator row', required=False)), ('show_avatar', wagtail.blocks.BooleanBlock(label='Show avatar', required=False)), ('avatar_location', wagtail.blocks.ChoiceBlock(choices=[('start', 'Before username'), ('end', 'After username')], label='Avatar location', required=False)), ('show_email', wagtail.blocks.BooleanBlock(label='Show the email of page creator', required=False)), ('email_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator email is displayed.', label='Header of the page creator email row', required=False)), ('show_first_published_at', wagtail.blocks.BooleanBlock(label='Date of page publication', required=False)), ('first_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page publciation date is displayed.', label='Header of the page publication date', required=False)), ('show_last_published_at', wagtail.blocks.BooleanBlock(label='Date of last page update', required=False)), ('last_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the last page update is displayed.', label='Header of last page update', required=False)), ('datetime_style', wagtail.blocks.ChoiceBlock(choices=[('date', 'Only date'), ('datetime', 'Date and time'), ('timesince', 'Time since')], label='Date style')), ('time_format', wagtail.blocks.ChoiceBlock(choices=[('G:i', '24-hour format'), ('g:i A', '12-hour format')], label='Time format')), ('timesince_text', wagtail.blocks.CharBlock(label='Time since text, e.g. ago', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('row_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row header style', required=False)), ('row_data_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row style', required=False))]))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock()), ('post_meta', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon')), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_categories', wagtail.blocks.BooleanBlock(default=True, label='Show post categories', required=False)), ('categories_header', wagtail.blocks.CharBlock(help_text='Text to display before categories list.', label='Categories header', required=False)), ('categories_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Categories header style', required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Categories link style', required=False)), ('show_tags', wagtail.blocks.BooleanBlock(default=True, label='Show post tags', required=False)), ('tags_header', wagtail.blocks.CharBlock(help_text='Text to display before tag list.', label='Tags header', required=False)), ('tags_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags header style', required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags link style', required=False)), ('show_sibling_posts', wagtail.blocks.BooleanBlock(default=True, help_text='Shows previous and next posts for the current post. Previous means either previously (chronologically) published or previous post from the series. Next means either (chronologically) published next or next post from the series.', label='Show previous and next posts', required=False)), ('previous_post', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('header', wagtail.blocks.CharBlock(label='Header: e.g. "Next post"', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon')), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('post_link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Post link style', required=False))], label='Previous post')), ('next_post', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('header', wagtail.blocks.CharBlock(label='Header: e.g. "Next post"', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon')), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('post_link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Post link style', required=False))], label='Next post'))])), ('post_series', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('current_post_style', wagtail.blocks.ChoiceBlock(choices=[('active', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Current post style'))]))]))], blank=True, use_json_field=True)),
                ('pin_in_list', models.BooleanField(default=False, help_text='Indicates if the post is pinned on the post list page.', verbose_name='Pin in list')),
                ('categories', modelcluster.fields.ParentalManyToManyField(blank=True, to='waggylabs.postcategory', verbose_name='Categories')),
            ],
            options={
                'abstract': False,
            },
            bases=('waggylabs.basepage',),
        ),
        migrations.CreateModel(
            name='SitePage',
            fields=[
                ('basepage_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='waggylabs.basepage')),
                ('repeat_in_subnav', models.BooleanField(default=False, help_text="If checked, a link to this page will be repeated alongside it's direct children when displaying a sub-navigation for this page.", verbose_name='repeat in sub-navigation')),
                ('repeated_item_text', models.CharField(blank=True, help_text="e.g. 'Section home' or 'Overview'. If left blank, the page title will be used.", max_length=255, verbose_name='repeated item link text')),
                ('body', wagtail.fields.StreamField([('accordion', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('collapsible', 'Items collapse'), ('stays_open', 'Items stay open')], help_text='Collapse items when new items opens or keep them open', label='Item collapse style')), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('heading', wagtail.blocks.CharBlock(form_classname='full subtitle', label='Item heading', required=True)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('is_open', wagtail.blocks.BooleanBlock(label='Item is displayed expanded', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], required=False))])))])), ('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('card_grid', wagtail.blocks.StructBlock([('height_style', wagtail.blocks.ChoiceBlock(choices=[('h-100', 'Equal height'), ('', 'Height wraps to content')], label='Card height style', required=False)), ('grouping_style', wagtail.blocks.ChoiceBlock(choices=[('separate', 'Separate'), ('grouped', 'Grouped')], label='Card grouping style', required=False)), ('orientation_style', wagtail.blocks.ChoiceBlock(choices=[('vertical', 'Vertical'), ('horizontal', 'Horizontal')], label='Card orientation', required=False)), ('columns', wagtail.blocks.ChoiceBlock(choices=[(1, '1 column'), (2, '2 columns'), (3, '3 columns')], label='Number of columns', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Image', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('title', wagtail.blocks.CharBlock(label='Card title', required=True)), ('subtitle', wagtail.blocks.CharBlock(label='Card subtitle', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, required=False)), ('links', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('email', wagtail.blocks.StructBlock([('email', wagtail.blocks.EmailBlock(label='Email address', required=True)), ('text', wagtail.blocks.CharBlock(label='Text instead of email', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Email icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Email icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Email style', required=False))])), ('info_text', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Phone, address, etc.', required=True)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Style', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Icon location', required=False))]))], required=False))])))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('collapse', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the button', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False)), ('button_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], requred=True))])), ('columns', wagtail.blocks.StructBlock([('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('vertical_align', wagtail.blocks.ChoiceBlock(choices=[('align-self-start', 'Top'), ('align-self-center', 'Center'), ('align-self-end', 'Bottom')], label='Column content vertical alignment')), ('body', wagtail.blocks.StreamBlock([('accordion', wagtail.blocks.StructBlock([('style', wagtail.blocks.ChoiceBlock(choices=[('collapsible', 'Items collapse'), ('stays_open', 'Items stay open')], help_text='Collapse items when new items opens or keep them open', label='Item collapse style')), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('heading', wagtail.blocks.CharBlock(form_classname='full subtitle', label='Item heading', required=True)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('is_open', wagtail.blocks.BooleanBlock(label='Item is displayed expanded', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], required=False))])))])), ('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('collapse', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the button', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False)), ('button_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Block style', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('body', wagtail.blocks.StreamBlock([('blockquote', wagtail.blocks.StructBlock([('quote', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Quote text.', required=True)), ('author', wagtail.blocks.CharBlock(label='Author of the quoted text.', required=False)), ('source', wagtail.blocks.CharBlock(label='Source of the quoted text.', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-blockquote', max_length=50, required=False)), ('aligntment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('show_icon', wagtail.blocks.BooleanBlock(label='Show quote icon', required=False))])), ('carousel', wagtail.blocks.StructBlock([('switch', wagtail.blocks.ChoiceBlock(choices=[('carousel-fade', 'Fade after interval'), ('carousel', 'Change after interval'), ('false', 'Change on button'), ('false-fade', 'Fade on button')], label='Carousel switch type')), ('controls', wagtail.blocks.ChoiceBlock(choices=[('', 'No controls'), ('buttons', 'Left and right buttons'), ('indicators', 'Items indicators'), ('buttons_indicators', 'Buttons and indicators')], label='Controls of the carousel', required=False)), ('items', wagtail.blocks.ListBlock(wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Picture for carousel', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,heading,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', label='Text in front of the picture', required=False)), ('interval', wagtail.blocks.IntegerBlock(default=1000, help_text='Enter the value in milliseconds to keep the current item during this interval', label='Interval in milliseconds to keep the item', min_value=0, required=False)), ('text_justify', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('text_color', wagtail.blocks.ChoiceBlock(choices=[('text-light', 'Light'), ('text-dark', 'Dark')], label='Text color', required=False)), ('text_size', wagtail.blocks.ChoiceBlock(choices=[('fs-6', 'Normal'), ('fs-5', 'Bigger'), ('fs-4', 'Big'), ('fs-3', 'Larger'), ('fs-2', 'Large')], label='Text size', required=False))]), min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='', required=False))], requred=True))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock(help_text=''))], required=False))]), max_num=3, min_num=1))])), ('citation', wagtail.blocks.StructBlock([('citation', wagtail.blocks.CharBlock(label='Title of the citation.', required=False)), ('link', wagtail.blocks.URLBlock(label='Citation link', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite literature using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('cut', wagtail.blocks.StructBlock([('text', wagtail.blocks.CharBlock(label='Text on the cut button', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Button icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Button icon location', required=False))])), ('document', wagtail.blocks.StructBlock([('document', wagtail.documents.blocks.DocumentChooserBlock()), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-cite', help_text='Cite documents using LaTeX \\cite{...} syntax in text markdown block.', required=False))])), ('embed', wagtail.blocks.StructBlock([('embed', wagtail.embeds.blocks.EmbedBlock(label='URL of embedding')), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Embed caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-embed', max_length=50, required=False))])), ('equation', wagtail.blocks.StructBlock([('equation', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='false', max_height='150px', min_height='150px', statusbar='false', toolbar='subscript,superscript,equation,matrix,align,multiline,split,gather,alignat,flalign,|,preview,side-by-side,fullscreen', help_text='Write or paste LaTeX style equation (equation, matrix, align, etc. environments are supported). ', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text='Caption that will be displayed when the equation is shown in the dialog box or in the sidebar.', label='Equation caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-equation', help_text='Label for the current equation to be used in the markdown block for referencing using standard LaTeX \\ㅤref{...} syntax. This label will be added only if no \\ㅤlabel{...} is found within the \\ㅤbegin{...}...\\ㅤend{...} statement.The final reference processing is happening on the published page, which can be checked using "Preview" functionality.', max_length=50, required=False))])), ('figure', wagtail.blocks.StructBlock([('image', wagtail.images.blocks.ImageChooserBlock(label='Graphic', required=True)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Figure caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-figure', max_length=50, required=False))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('listing', wagtail.blocks.StructBlock([('code', wagtail.blocks.StructBlock([('mode', wagtail.blocks.ChoiceBlock(choices=[('text/x-python', 'Python'), ('text/x-csrc', 'C'), ('text/x-c++src', 'C++'), ('text/x-java', 'Java/Kotlin'), ('text/x-csharp', 'C#'), ('text/x-objectivec', 'Objective C'), ('text/x-scala', 'Scala'), ('application/xml', 'XML'), ('text/html', 'HTML'), ('text/javascript', 'Javascipt'), ('text/json', 'JSON'), ('text/typescript', 'TypeScript'), ('text/x-mathematica', 'Mathematica'), ('text/x-octave', 'Matlab'), ('application/x-powershell', 'Powershell'), ('text/x-sh', 'Bach/Shell'), ('text/x-swift', 'Swift'), ('text/x-sql', 'SQL')], help_text='Choose the programming language.', label='Code language')), ('code', wagtail.blocks.TextBlock(help_text='Write or paste code.', label='Code snippet', required=True))], label=None)), ('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Listing caption', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-listing', max_length=50, required=False))])), ('page_info', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('show_user', wagtail.blocks.BooleanBlock(label='Show the name of the page creator', required=False)), ('user_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator name is displayed.', label='Header of the page creator row', required=False)), ('show_avatar', wagtail.blocks.BooleanBlock(label='Show avatar', required=False)), ('avatar_location', wagtail.blocks.ChoiceBlock(choices=[('start', 'Before username'), ('end', 'After username')], label='Avatar location', required=False)), ('show_email', wagtail.blocks.BooleanBlock(label='Show the email of page creator', required=False)), ('email_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page creator email is displayed.', label='Header of the page creator email row', required=False)), ('show_first_published_at', wagtail.blocks.BooleanBlock(label='Date of page publication', required=False)), ('first_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the page publciation date is displayed.', label='Header of the page publication date', required=False)), ('show_last_published_at', wagtail.blocks.BooleanBlock(label='Date of last page update', required=False)), ('last_published_at_header', wagtail.blocks.CharBlock(help_text='Displays the header of the row in which the last page update is displayed.', label='Header of last page update', required=False)), ('datetime_style', wagtail.blocks.ChoiceBlock(choices=[('date', 'Only date'), ('datetime', 'Date and time'), ('timesince', 'Time since')], label='Date style')), ('time_format', wagtail.blocks.ChoiceBlock(choices=[('G:i', '24-hour format'), ('g:i A', '12-hour format')], label='Time format')), ('timesince_text', wagtail.blocks.CharBlock(label='Time since text, e.g. ago', required=False)), ('alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('row_header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row header style', required=False)), ('row_data_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Row style', required=False))]))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_category', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post categories for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('categories_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Categories style', required=False)), ('categories_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all categories are shown.', label='Number of categories to show', min_value=0, required=True)), ('category_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Category item style', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Categories ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per category', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))])), ('post_tag_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('header_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('h1', 'Header 1'), ('h2', 'Header 2'), ('h3', 'Header 3'), ('h4', 'Header 4'), ('h5', 'Header 5'), ('h6', 'Header 6'), ('display-1', 'Display header 1'), ('display-2', 'Display header 2'), ('display-3', 'Display header 3'), ('display-4', 'Display header 4'), ('display-5', 'Display header 5'), ('display-6', 'Display header 6'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter'), ('fst-italic', 'Italic'), ('fw-bold fst-italic', 'Bold italic'), ('fw-bolder fst-italic', 'Bolder italic'), ('fw-semibold fst-italic', 'Semibold italic'), ('fw-light fst-italic', 'Light italic'), ('fw-lighter fst-italic', 'Lighter italic')], label='Header style', required=False)), ('block_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('border-primary', 'Border primary'), ('border-secondary', 'Border secondary'), ('border-success', 'Border success'), ('border-danger', 'Border danger'), ('border-warning', 'Border warning'), ('border-info', 'Border info'), ('border-light', 'Border light'), ('border-dark', 'Border dark'), ('border-0', 'No border'), ('border-0 mp-0', 'No border, no margin')], label='Card style', required=False)), ('block_alignment', wagtail.blocks.ChoiceBlock(choices=[('', 'Left'), ('text-center', 'Center'), ('text-end', 'Right')], label='Text alignment', required=False)), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows post tags for the posts, which are children of the selected post list page. If left empty, the currently browsed post list page will be used. Otherwise, no categories will be displayed.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('tags_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Tags style', required=False)), ('tags_number', wagtail.blocks.IntegerBlock(default=10, help_text='Depends on the selected order. If equals to zero, then all tags are shown.', label='Number of tags to show', min_value=0, required=True)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('slug', 'By slug acsending'), ('-slug', 'By slug descending'), ('num_posts', 'By post number acsending'), ('-num_posts', 'By post number descending')], label='Tags ordering', required=False)), ('show_badges', wagtail.blocks.BooleanBlock(label='Show number of posts per tag', required=False)), ('badge_style', wagtail.blocks.ChoiceBlock(choices=[('text-bg-primary', 'Primary'), ('text-bg-secondary', 'Secondary'), ('text-bg-success', 'Success'), ('text-bg-danger', 'Danger'), ('text-bg-warning', 'Warning'), ('text-bg-info', 'Info'), ('text-bg-light', 'Light'), ('text-bg-dark', 'Dark'), ('rounded-pill text-bg-primary', 'Rounded primary'), ('rounded-pill text-bg-secondary', 'Rounded secondary'), ('rounded-pill text-bg-success', 'Rounded success'), ('rounded-pill text-bg-danger', 'Rounded danger'), ('rounded-pill text-bg-warning', 'Rounded warning'), ('rounded-pill text-bg-info', 'Rounded info'), ('rounded-pill text-bg-light', 'Rounded light'), ('rounded-pill text-bg-dark', 'Rounded dark')], label='Post number style', required=False)), ('badge_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('position-absolute top-0 start-100 translate-middle', 'Top right corner'), ('position-absolute top-0 start-0 translate-middle', 'Top left corner'), ('position-absolute top-100 start-100 translate-middle', 'Bottom right corner'), ('position-absolute top-100 start-0 translate-middle', 'Bottom left corner')], label='Post number location', required=False))]))])), ('table', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('table', waggylabs.blocks.table.BareTableBlock(help_text='Columns and rows can be added via context menu appearing on the right click. Markdown inside cells is supported. Inline LateX equations can be added using $...$ pattern.', keep_table_tag=False, label='Table data', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('table_figure', wagtail.blocks.StructBlock([('caption', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='150px', min_height='150px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table caption', required=False)), ('image', wagtail.images.blocks.ImageChooserBlock(label='Table image', required=True)), ('footer', waggylabs.blocks.markdown.MarkdownBlock(stex_combine='true', max_height='100px', min_height='100px', statusbar='false', toolbar='bold,italic,strikethrough,|,unordered-list,ordered-list,link,|,code,subscript,superscript,|,preview,side-by-side,fullscreen,guide', help_text=None, label='Table footer', required=False)), ('label', waggylabs.blocks.label.LabelBlock(form_classname='waggylabs-label-table', max_length=50, required=False))])), ('text', waggylabs.blocks.markdown.MarkdownBlock())], use_json_field=True)),
            ],
            options={
                'abstract': False,
            },
            bases=('waggylabs.basepage', models.Model),
        ),
        migrations.CreateModel(
            name='WaggyLabsSettings',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('site_slogan', models.CharField(blank=True, help_text='Phrase, that appears in navbar on the right to the brand image.', max_length=255, verbose_name='Slogan')),
                ('show_site_name', models.BooleanField(default=True, help_text='Indicates if title of the Waggy Labs site appears in navigation bar and in browser tab e.g., Page Title - Site Name.', verbose_name='Show site name in navigation bar and browser tab')),
                ('site_name_separator', models.CharField(blank=True, help_text='Separator for site name e.g., Page Title - Site Name or Page Title : Site Name.', max_length=10, verbose_name='Separator for the site name')),
                ('site_name_alignment', models.CharField(choices=[('before_title', 'Before page title'), ('after_title', 'After page title')], default='after_title', help_text='The alignment of site name: before or after page title.', max_length=25, verbose_name='Site name alignment')),
                ('site_theme', models.FileField(blank=True, help_text='CSS file with theme to be used instead of default Bootstrap theme.', upload_to='', verbose_name='Bootstrap CSS theme')),
                ('theme_supports_color_mode', models.BooleanField(blank=True, default=True, help_text='If the CSS theme file suppots Bootstrap dark and light modes.', verbose_name='CSS theme supports dark and light modes')),
                ('menu_max_levels', models.IntegerField(default=1, help_text='Specifies how deep in the page hierarchy the menu must be rendered, i.e. what is the level of depth to render the dropdown submenus.', validators=[django.core.validators.MinValueValidator(1, message='Maximum number of menu levels cannot be less than 1.')], verbose_name='Maximum number of menu levels')),
                ('menu_allow_repeating_parents', models.BooleanField(blank=True, default=1, verbose_name='Repeat parent links in the dropdown submenus')),
                ('navbar_color', models.CharField(blank=True, default='', help_text='Choose a specific color and opacity for the navigation bar. If none specified, the default theme color is used.', max_length=25, verbose_name='Navigation bar color')),
                ('navbar_link_color', models.CharField(blank=True, default='', help_text='Specifies the color and opacity for the navigation bar links. If none specified, the default theme color is used.', max_length=25, verbose_name='Navigation bar link color')),
                ('navbar_hover_link_color', models.CharField(blank=True, default='', help_text='Specifies the color and opacity for the navigation bar links during hover. If none specified, the default theme color is used.', max_length=25, verbose_name='Navigation bar hover link color')),
                ('navbar_link_weight', models.CharField(blank=True, choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-medium', 'Medium'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter')], default='', help_text='Specifies the font weigth for the navigation bar links.', max_length=25, verbose_name='Navigation bar link weight')),
                ('navbar_active_link_color', models.CharField(blank=True, default='', help_text='Specifies the color and opacity for the navigation bar active links. If nothing chosen, navigation bar link color is used if it was specified. Otherwise the default theme color is used.', max_length=25, verbose_name='Navigation bar active link color')),
                ('navbar_active_link_weight', models.CharField(blank=True, choices=[('', 'Default'), ('fw-bold', 'Bold'), ('fw-bolder', 'Bolder'), ('fw-semibold', 'Semibold'), ('fw-medium', 'Medium'), ('fw-normal', 'Normal'), ('fw-light', 'Light'), ('fw-lighter', 'Lighter')], default='', help_text='Specifies the font weigth for the navigation bar active links.', max_length=25, verbose_name='Navigation bar active link weight')),
                ('navbar_placement', models.CharField(blank=True, choices=[('', 'Default'), ('sticky-top', 'Sticky top')], default='', help_text='Navigation bar placement options: default, sticky-top or fixed-top. See Bootstrap documentation.', max_length=10, verbose_name='Navigation bar menu placement')),
                ('navbar_menu_alignment', models.CharField(choices=[('left', 'Left'), ('middle', 'Middle'), ('right', 'Right')], default='left', help_text='Menu links alignment in the navigation bar.', max_length=10, verbose_name='Navigation bar menu alignment')),
                ('navbar_links', wagtail.fields.StreamField([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], blank=True, use_json_field=True, verbose_name='Navigation bar links')),
                ('content_width', models.CharField(choices=[('narrow', 'Narrow'), ('medium', 'Medium'), ('wide', 'Wide')], default='medium', help_text='Sets the width of the main content of any page. Final width depends on the presence of a sidebar on a particlar page.', max_length=10, verbose_name='Page content width')),
                ('constant_content_width', models.BooleanField(blank=True, default=False, help_text='Keep the width of the page content always the same indepent from presence or absence of sidebar on the page. If true, when the sidebar is not present on the page, its place stays empty without change of page content width.', verbose_name='Keep content width constant')),
                ('copyright_icon', models.CharField(blank=True, help_text='Icon to used in front of the copyright phrase.', max_length=255, verbose_name='Copyright icon')),
                ('copyright_info', models.CharField(blank=True, help_text='Information about the copyright holder.', max_length=255, verbose_name='Copyright information')),
                ('content_license_link', models.URLField(blank=True, help_text='Link to the license for the content. For example, to link to CC BY 3.0 license text.', verbose_name='Link to content license')),
                ('content_license_text', models.CharField(blank=True, help_text='Text to put for the license link', max_length=255, verbose_name='Text of the license link')),
                ('footer', wagtail.fields.StreamField([('footer_menu', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('col_offset', wagtail.blocks.ChoiceBlock(choices=[('', 'No offset'), ('offset-lg-1', 'Narrow'), ('offset-lg-2', 'Medium'), ('offset-lg-3', 'Wide')], label='Offset', required=False)), ('col_width', wagtail.blocks.ChoiceBlock(choices=[('col-lg-2', 'Narrow'), ('col-lg-3', 'Medium'), ('col-lg-4', 'Wide')], label='Width')), ('item', wagtail.blocks.StructBlock([('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False))]))])), ('link_list', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('col_offset', wagtail.blocks.ChoiceBlock(choices=[('', 'No offset'), ('offset-lg-1', 'Narrow'), ('offset-lg-2', 'Medium'), ('offset-lg-3', 'Wide')], label='Offset', required=False)), ('col_width', wagtail.blocks.ChoiceBlock(choices=[('col-lg-2', 'Narrow'), ('col-lg-3', 'Medium'), ('col-lg-4', 'Wide')], label='Width')), ('item', wagtail.blocks.StructBlock([('link_list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Link list style', required=False)), ('link_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark')], label='Link item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('items', wagtail.blocks.StreamBlock([('external_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.URLBlock(label='Link to external site', required=True)), ('text', wagtail.blocks.CharBlock(label='Text of the link', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))])), ('internal_link', wagtail.blocks.StructBlock([('link', wagtail.blocks.PageChooserBlock(label='Link to a page of this site')), ('text', wagtail.blocks.CharBlock(label='Text instead of page title', required=False)), ('icon', waggylabs.blocks.icon.IconBlock(label='Link icon', required=False)), ('icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Link icon location', required=False)), ('style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info')], label='Link style', required=False))]))], use_json_field=True))], label='List of links'))])), ('post_archive', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('col_offset', wagtail.blocks.ChoiceBlock(choices=[('', 'No offset'), ('offset-lg-1', 'Narrow'), ('offset-lg-2', 'Medium'), ('offset-lg-3', 'Wide')], label='Offset', required=False)), ('col_width', wagtail.blocks.ChoiceBlock(choices=[('col-lg-2', 'Narrow'), ('col-lg-3', 'Medium'), ('col-lg-4', 'Wide')], label='Width')), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('list_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Archive links list style', required=False)), ('archives_number', wagtail.blocks.IntegerBlock(default=0, help_text='If zero, all links are shown.', label='Number of archive links to show', min_value=0, required=True)), ('list_item_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Archive link style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('archive_period', wagtail.blocks.ChoiceBlock(choices=[('day', 'By day'), ('month', 'By month'), ('year', 'By year')], label='Period of archive link')), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('DESC', 'Descneding'), ('ASC', 'Ascending')], label='Archive links order')), ('more_archive_text', wagtail.blocks.CharBlock(help_text='When number of archive links is larger than number of archive links to show, button to show more links appears with the specified text.', label='More archives button text', required=False))]))])), ('post_highlights', wagtail.blocks.StructBlock([('header', wagtail.blocks.CharBlock(label='Header text', required=False)), ('header_icon', waggylabs.blocks.icon.IconBlock(label='Header icon', required=False)), ('header_icon_location', wagtail.blocks.ChoiceBlock(choices=[('', 'Before text'), ('end', 'After text')], label='Header icon location', required=False)), ('col_offset', wagtail.blocks.ChoiceBlock(choices=[('', 'No offset'), ('offset-lg-1', 'Narrow'), ('offset-lg-2', 'Medium'), ('offset-lg-3', 'Wide')], label='Offset', required=False)), ('col_width', wagtail.blocks.ChoiceBlock(choices=[('col-lg-2', 'Narrow'), ('col-lg-3', 'Medium'), ('col-lg-4', 'Wide')], label='Width')), ('item', wagtail.blocks.StructBlock([('post_list_page', wagtail.blocks.PageChooserBlock(help_text='Shows only posts that are descendant of this page. If left empty, posts selected from all the posts are shown.', label='Root post list page', page_type=['waggylabs.PostListPage'], required=False)), ('posts_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list'), ('list-unstyled', 'Unstyled list'), ('list-numbered', 'Numbered list'), ('list-group', 'List group'), ('list-group list-group-flush', 'List group, no outer borders'), ('list-group list-group-numbered', 'Numbered list group'), ('list-group list-group-numbered list-group-flush', 'Numbered list group, no outer borders')], label='Post list style', required=False)), ('posts_number', wagtail.blocks.IntegerBlock(help_text='If zero, all post are shown.', label='Number of posts to show', min_value=0, required=True)), ('post_style', wagtail.blocks.ChoiceBlock(choices=[('', 'Default list item'), ('list-group-item list-group-item-action', 'List group item'), ('list-group-item list-group-item-action list-group-item-primary', 'List group item primary'), ('list-group-item list-group-item-action list-group-item-secondary', 'List group item secondary'), ('list-group-item list-group-item-action list-group-item-success', 'List group item success'), ('list-group-item list-group-item-action list-group-item-danger', 'List group item danger'), ('list-group-item list-group-item-action list-group-item-warning', 'List group item warning'), ('list-group-item list-group-item-action list-group-item-info', 'List group item info'), ('list-group-item list-group-item-action list-group-item-light', 'List group item light'), ('list-group-item list-group-item-action list-group-item-dark', 'List group item dark'), ('btn btn-primary', 'Button primary'), ('btn btn-secondary', 'Button secondary'), ('btn btn-success', 'Button success'), ('btn btn-danger', 'Button danger'), ('btn btn-warning', 'Button warning'), ('btn btn-info', 'Button info'), ('btn btn-outline-primary', 'Button outline primary'), ('btn btn-outline-secondary', 'Button outline secondary'), ('btn btn-outline-success', 'Button outline success'), ('btn btn-outline-danger', 'Button outline danger'), ('btn btn-outline-warning', 'Button outline warning'), ('btn btn-outline-info', 'Button outline info'), ('card-link', 'Card link'), ('nav-link', 'Navigation bar link'), ('nav-link active', 'Navigation bar active link'), ('link-primary', 'Primary link'), ('link-secondary', 'Secondary link'), ('link-success', 'Success link'), ('link-danger', 'Danger link'), ('link-warning', 'Warning link'), ('link-info', 'Info link'), ('link-light', 'Light link'), ('link-dark', 'Dark link'), ('nav-link link-primary', 'Primary link, no underline'), ('nav-link link-secondary', 'Secondary link, no underline'), ('nav-link link-success', 'Success link, no underline'), ('nav-link link-danger', 'Danger link, no underline'), ('nav-link link-warning', 'Warning link, no underline'), ('nav-link link-info', 'Info link, no underline'), ('nav-link link-light', 'Light link, no underline'), ('nav-link link-dark', 'Dark link, no underline')], label='Post title item style', required=False)), ('text_wrap', wagtail.blocks.ChoiceBlock(choices=[('', 'Text wrap'), ('text-nowrap', 'No text wrapping')], label='Text wrapping', required=False)), ('order_by', wagtail.blocks.ChoiceBlock(choices=[('created_at', 'Older first'), ('-created_at', 'Newer first'), ('title', 'By title acsending'), ('-title', 'By title descending'), ('owner__username', 'By author ascending'), ('-owner__username', 'By author descending')], label='Posts ordering', required=False))]))]))], blank=True, use_json_field=True)),
                ('search_in_menu', models.BooleanField(blank=True, default=True, verbose_name='Show search button in the menu')),
                ('search_results_per_page', models.IntegerField(default=10, validators=[django.core.validators.MinValueValidator(1, message='Number of search results per page cannot be less than 1.')], verbose_name='Number of search results per page')),
                ('paginator_alignment', models.CharField(choices=[('justify-content-start', 'Left'), ('justify-content-center', 'Center'), ('justify-content-end', 'Right')], default='justify-content-center', help_text='Sets the paginator alignment on the page.', max_length=25, verbose_name='Paginator alignment')),
                ('paginator_size', models.CharField(blank=True, choices=[('', 'Normal'), ('pagination-sm', 'Small'), ('pagination-lg', 'Large')], default='', help_text='Sets the paginator text and icon size.', max_length=15, verbose_name='Paginator size')),
                ('first_page_text', models.CharField(blank=True, help_text='Text for the first button text.', max_length=255, verbose_name='First page button text')),
                ('first_page_icon', models.CharField(blank=True, help_text='Icon for the first button text.', max_length=255, verbose_name='First page button icon')),
                ('previous_page_text', models.CharField(blank=True, help_text='Text for the previous button text.', max_length=255, verbose_name='Previous page button text')),
                ('previous_page_icon', models.CharField(blank=True, help_text='Icon for the previous button text.', max_length=255, verbose_name='Previous page button icon')),
                ('next_page_text', models.CharField(blank=True, help_text='Text for the next button text.', max_length=255, verbose_name='Next page button text')),
                ('next_page_icon', models.CharField(blank=True, help_text='Icon for the next button text.', max_length=255, verbose_name='Next page button icon')),
                ('last_page_text', models.CharField(blank=True, help_text='Text for the last button text.', max_length=255, verbose_name='Last page button text')),
                ('last_page_icon', models.CharField(blank=True, help_text='Icon for the last button text.', max_length=255, verbose_name='Last page button icon')),
                ('site', models.OneToOneField(editable=False, on_delete=django.db.models.deletion.CASCADE, to='wagtailcore.site')),
                ('site_icon', models.ForeignKey(blank=True, help_text='Brand icon that appears in navigation bar and in the browser tab.', null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to='wagtailimages.image', verbose_name='Site icon')),
            ],
            options={
                'verbose_name': 'Waggy Labs Settings',
            },
        ),
        migrations.CreateModel(
            name='PostPageTag',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('tag', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='%(app_label)s_%(class)s_items', to='taggit.tag')),
                ('content_object', modelcluster.fields.ParentalKey(on_delete=django.db.models.deletion.CASCADE, related_name='post_page_tags', to='waggylabs.postpage')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='postpage',
            name='tags',
            field=modelcluster.contrib.taggit.ClusterTaggableManager(blank=True, help_text=None, through='waggylabs.PostPageTag', to='taggit.Tag', verbose_name='Tags'),
        ),
        migrations.CreateModel(
            name='PostPagePostCategory',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('post_category', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='post_pages', to='waggylabs.postcategory')),
                ('post_page', modelcluster.fields.ParentalKey(on_delete=django.db.models.deletion.CASCADE, related_name='post_categories', to='waggylabs.postpage')),
            ],
            options={
                'unique_together': {('post_page', 'post_category')},
            },
        ),
    ]
